package hello.corba;

import hello.corba.generated.*;

/**
 * Implementao de Circulo como objeto remoto CORBA
 */
public class CirculoImpl extends CirculoRemotePOA {
    private int raio;
    private PontoRemote origem;
    
    public CirculoImpl(int raio, PontoRemote origem) {
        this.raio = raio;
        this.origem = origem;
    }
    
    public int getRaio() {
        return raio;
    }
    
    public PontoRemote getOrigem() {
        return origem;
    }
    
    public void setOrigem(PontoRemote p) {
        origem = p;
    }
    
    public void setRaio(int raio) {
        this.raio = raio;
    }
    
    public String toStringRemote() {
        return "Circulo de raio " + raio + " em " + origem.toStringRemote() + ".";
    }
    
    public boolean equalsRemote(org.omg.CORBA.Any obj) {
        if ( !(obj instanceof CirculoRemote)) return false;
        CirculoRemote outro = (CirculoRemote) obj;
        return raio == outro.getRaio() && origem.equals(outro.getOrigem());
    }
}
