package hello.corba;

import hello.corba.generated.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POAPackage.*;
import org.omg.CORBA.*;

public class HelloRpImpl extends  HelloRpRemotePOA {
    
    private NomeRemote msgObject;
    private CirculoRemote circulo;
    private POA rootPOA;
    private ORB orb;
    
    public HelloRpImpl(NomeRemote msgObject, CirculoRemote circulo) {
        this.msgObject = msgObject;
        this.circulo = circulo;
    }
    
    public void setORB (ORB orb) {
        this.orb = orb;
    }
    
    public void initPOA() throws Exception {
        rootPOA = POAHelper.narrow( orb.resolve_initial_references("RootPOA") );
        rootPOA.the_POAManager().activate();
    }
        
    public String sayHello() {
        return msgObject.getNome();
    }
    public void sayThis(String toSay) {
        msgObject.setNome(toSay);
    }
    
    public NomeRemote getMessage() {
        return msgObject;
    }
    public void setMessage(NomeRemote mensagem)  {
        msgObject = mensagem;
    }
    
    public CirculoRemote getCirculo()  {
        return circulo;
    }
    public void setCirculo(CirculoRemote circulo)   {
        this.circulo = circulo;
    }
    
    public CirculoRemote createCirculo(int raio, PontoRemote origem) {
        CirculoImpl crobj = new CirculoImpl(raio, origem);
        org.omg.CORBA.Object circRef = null;
        try {
            circRef = rootPOA.servant_to_reference(crobj);
        } catch (org.omg.CORBA.UserException e) {
            return null;
        }
        return CirculoRemoteHelper.narrow(circRef);
    }
    public PontoRemote createPonto(int x, int y) {
        PontoImpl probj = new PontoImpl(x, y);
        org.omg.CORBA.Object ptoRef = null;
        try {
            ptoRef = rootPOA.servant_to_reference(probj);
        } catch (org.omg.CORBA.UserException e) {
            return null;
        }
        return PontoRemoteHelper.narrow(ptoRef);
    }
    public NomeRemote createNome(String nome) {
        NomeImpl nrobj = new NomeImpl(nome);
        org.omg.CORBA.Object nomeRef = null;
        try {
            nomeRef = rootPOA.servant_to_reference(nrobj);
        } catch (org.omg.CORBA.UserException e) {
            return null;
        }
        return NomeRemoteHelper.narrow(nomeRef);
    }
}
