package hello.rmi;

import java.rmi.*;

import hello.*;
import hello.unicast.*;

public class HelloRpImpl extends java.rmi.server.UnicastRemoteObject implements HelloRpRemote {
    
    private NomeRemote msgObject;
    private CirculoRemote circulo;
    
    public HelloRpImpl(NomeRemote msgObject, CirculoRemote circulo) throws RemoteException {
        this.msgObject = msgObject;
        this.circulo = circulo;
    }
        
    public String sayHello() throws RemoteException {
        return msgObject.getNome();
    }
    public void sayThis(String toSay) throws RemoteException {
        msgObject.setNome(toSay);
    }
    
    public NomeRemote getMessage() throws RemoteException {
        return msgObject;
    }
    public void setMessage(NomeRemote mensagem)  throws RemoteException {
        msgObject = mensagem;
    }
    
    public CirculoRemote getCirculo()  throws RemoteException {
        return circulo;
    }
    public void setCirculo(CirculoRemote circulo)  throws RemoteException  {
        this.circulo = circulo;
    }
    
    public CirculoRemote createCirculo(int raio, PontoRemote origem) throws RemoteException {
        return new CirculoImpl(raio, createPonto(30, 40));
    }
    public PontoRemote createPonto(int x, int y) throws RemoteException {
        return new PontoImpl(x, y);
    }
    public NomeRemote createNome(String nome) throws RemoteException {
        return new NomeImpl(nome);
    }
    
}
