package hello.unicast;

import java.rmi.server.UnicastRemoteObject;
import java.rmi.*;

import hello.*;

public class PontoImpl extends UnicastRemoteObject implements PontoRemote {
    private int x, y;
    
    public PontoImpl(int x, int y) throws RemoteException {
        this.x = x;
        this.y = y;
    }
    
    public int getX() throws RemoteException {
        return x;
    }
    
    public int getY() throws RemoteException {
        return y;
    }
    
    public void setX(int x) throws RemoteException {
        this.x = x;
    }
    
    public void setY(int y) throws RemoteException {
        this.y = y;
    }
    
    public String toStringRemote() throws RemoteException {
        return "(" + x + ", " + y + ")";
    }
    
    public boolean equalsRemote(Object obj) throws RemoteException {
        if ( !(obj instanceof PontoRemote)) return false;
        PontoRemote outro = (PontoRemote) obj;
        return x == outro.getX() && y == outro.getY();
    }
}
