package loja;

import java.math.BigDecimal;
import java.rmi.*;

/**
 * Exercicio: conecte este objeto ao DAO. Use ProdutoVO
 * para receber dados do DAO.
 */
public class ProdutoImpl extends javax.rmi.PortableRemoteObject
                       			 implements Produto {
	
	private String codigo;
	private String nome;
	private BigDecimal preco;
	private int quantidade;
	
	ProdutoDAO dao;

	/**
	 * Cria novo produto com codigo, nome, preco e quantidade em estoque.
	 */
	public ProdutoImpl(String codigo, String nome, BigDecimal preco, int quantidade)  throws RemoteException {
		System.out.println("ProdutoImpl("+codigo+","+nome+","+preco+","+quantidade+")");
		this.codigo = codigo;
		this.nome = nome;
		this.preco = preco;
		this.quantidade = quantidade;
		
		try {
			dao = new ProdutoDAO();
		} catch (DataAccessException e) {
			throw new RemoteException("Falha ao inicializar o DAO: " + e);
		}
		
		// cria o objeto (no banco) e recebe de volta o codigo
		/** (1) Crie o objeto usando dao.create()
		
		// atualiza os atributos de dados deste objeto com os do banco
		/** (2) Carregue os dados do banco para este objeto 
		        Dica: crie um metodo load(codigo) que faca isto
				e chame-o. (veja 4)*/
	}

	// Metodos de negocio
	
	public String getCodigo()  throws RemoteException {
		System.out.println("ProdutoImpl: getCodigo()");
		return codigo;
	}
	public void setCodigo(String codigo)  throws RemoteException {
		System.out.println("ProdutoImpl: setCodigo("+codigo+")");
		this.codigo = codigo;
		/** (3) Grave as alteraoes no banco 
		        Dica: crie um metodo save() grave o objeto inteiro
				e chame-o. (veja 5)*/
	}
	
	public void setNome(String nome)  throws RemoteException {
		System.out.println("ProdutoImpl: setNome("+nome+")");
		this.nome = nome;
		/** (3) Grave as alteraoes no banco 
		        Dica: crie um metodo save() grave o objeto inteiro
				e chame-o. (veja 5)*/
	}
	public String getNome()  throws RemoteException {
		System.out.println("ProdutoImpl: getNome()");
		return nome;
	}
	
	public void setPreco(BigDecimal preco)  throws RemoteException {
		System.out.println("ProdutoImpl: setPreco("+preco+")");
		this.preco = preco;
		/** (3) Grave as alteraoes no banco 
		        Dica: crie um metodo save() grave o objeto inteiro
				e chame-o. (veja 5)*/
	}
	public BigDecimal getPreco()  throws RemoteException {
		System.out.println("ProdutoImpl: getPreco()");
		return preco;
	}
	
	public int getQuantidade()  throws RemoteException {
		System.out.println("ProdutoImpl: getQuantidade()");
		return quantidade;
	}
	public void setQuantidade(int quantidade)  throws RemoteException {
		System.out.println("ProdutoImpl: setQuantidade("+quantidade+")");
		this.quantidade = quantidade;
		/** (3) Grave as alteraoes no banco 
		        Dica: crie um metodo save() grave o objeto inteiro
				e chame-o. (veja 5)*/
	}
	
	public void addItens(int quantidade)  throws RemoteException {
		System.out.println("ProdutoImpl: addItens("+quantidade+")");
		this.quantidade += quantidade;
		/** (3) Grave as alteraoes no banco 
		        Dica: crie um metodo save() grave o objeto inteiro
				e chame-o. (veja 5)*/
	}
	
	// Metodos de sincronizacao com o banco
	
	/**
	 * 
	 * Carrega o objeto do banco e atualiza as variaveis
	 * de instancia deste objeto.
	 */
	public void load(String codigo) throws RemoteException {
		System.out.println("ProdutoImpl: load("+codigo+")");
		/** (4) Chame dao.load() aqui e extraia as informacoes
		        do value object retornado, utilizando-as para
				atualizar o objeto. */
	}
	
	/**
	 * Persiste o estado deste objeto no banco.
	 */
	public void save() throws RemoteException {
		System.out.println("ProdutoImpl: save()");
		/** (5) Chame dao.store() aqui para gravar os
		        dados do objeto no banco. */
	}

}
