package loja;

import java.math.BigDecimal;
import java.rmi.*;

public class ProdutoFactoryImpl extends javax.rmi.PortableRemoteObject
                       			implements ProdutoFactory {
	
	ProdutoDAO dao;
	
	/**
	 * Inicializa a fabrica criando um DAO.
	 */
	public ProdutoFactoryImpl()  throws RemoteException {
		try {
			dao = new ProdutoDAO();
		} catch (DataAccessException e) {
			throw new RemoteException("Falha ao inicializar o DAO: " + e);
		}
	}
	
	/**
	 * Cria um novo produto remoto.
	 */
	public Produto criar(String nome, 
						 BigDecimal preco, 
						 int qte)  throws RemoteException {
		System.out.println("ProdutoFactoryImpl.criar("+nome+","+preco+","+qte+")");
		String cod = null;
		try {
			cod = dao.criarCodigo();
		} catch (DataAccessException e) {
			throw new RemoteException("Nao foi possivel criar codigo para novo produto: " + e);
		}
		return new ProdutoImpl(cod, nome, preco, qte);
	}
}
